/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#include <stdio.h>
#include "input.h"

#define INITIAL_BUFFER_SIZE     256

int is_the_stop_character(int c){
  return (c==EOF) || ((char)c=='\n');
}

char *input_a_line(){
  size_t buffer_dimension=INITIAL_BUFFER_SIZE*sizeof(char),
         string_dimension=0;
  char *r=(char*)malloc(buffer_dimension);
  int c;
  
  /* Read a char and append it to r until \n or EOF: */
  while(!is_the_stop_character(c=getchar())){
    string_dimension++;

    /* Resize the buffer when it becomes full:
       I resize one character before the buffer
       gets full to reserve space for \0. */
    if(string_dimension == buffer_dimension - 1)
      r=(char*)realloc(r,buffer_dimension *= 2);

    r[string_dimension-1]=(char)c;
  } /* while */

  /* Add NULL-termination and return: */
  r[string_dimension]='\0';
  return r;
}


